#include <vcl.h>
#pragma hdrstop

#include "MainDemo_.h"
#pragma package(smart_init)
#pragma link "MoDetect"
#pragma link "MoDetect"
#pragma resource "*.dfm"
TForm1 *Form1;

__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//------------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
   Edit3->Text = MotionDetector1->Grid;
   CheckBox2->Checked = MotionDetector1->ReduceVideoNoise;
   CheckBox1->Checked = MotionDetector1->CompareRed;
   CheckBox3->Checked = MotionDetector1->CompareGreen;
   CheckBox4->Checked = MotionDetector1->CompareBlue;
   CheckBox5->Checked = MotionDetector1->GreyScale;
   Memo2->Text = MotionDetector1->Get2DTextGrid();

   Edit4->Text = IntToStr (MotionDetector1->GridXCount());
   Edit8->Text = IntToStr (MotionDetector1->GridYCount());

   ComboBox1->Items->Text = VideoGrabber1->VideoDevices;
   ComboBox1->ItemIndex = VideoGrabber1->VideoDevice;

   // THE PROPERTIES BELOW CAN BE SET FROM THE OBJECT INSPECTOR
   VideoGrabber1->MotionDetector = MotionDetector1;  // connects the TMotionDetector component with the TVideoGrabber component
   VideoGrabber1->AutoRefreshPreview = true;         // restarts preview automatically when selecting a different video size
   VideoGrabber1->BurstMode = true;                  // enables automatic frame capture
   VideoGrabber1->BurstCount = 0;                    // not to stop capturing frames
   VideoGrabber1->BurstInterval = 0;                 // not to skip frames
}
//------------------------------------------------------------------------------

// occurs when TMotionDetector receives a new frame and motion is detected
//------------------------------------------------------------------------------
void __fastcall TForm1::MotionDetector1MotionDetected(TObject *Sender,
      double GlobalMotionRatio)
{
   Shape1->Brush->Color = clLime;
   Edit1->Text = FloatToStr (MotionDetector1->GlobalMotionRatio());
   Memo1->Text = MotionDetector1->Get2DTextMotion();
   Image1->Picture->Assign (MotionDetector1->LastFrame);
}
//------------------------------------------------------------------------------

// occurs when TMotionDetector receives a new frame and motion is NOT detected
//------------------------------------------------------------------------------
void __fastcall TForm1::MotionDetector1MotionNotDetected(TObject *Sender)
{
   Shape1->Brush->Color = clGreen;
   Edit1->Text = "";
   Memo1->Text = MotionDetector1->Get2DTextMotion();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::VideoGrabber1ChangeVideoDevice(TObject *Sender)
{
   ComboBox2->Items->Text = VideoGrabber1->AnalogVideoStandards;
   ComboBox2->ItemIndex = VideoGrabber1->AnalogVideoStandard;
   ComboBox2->Enabled = VideoGrabber1->IsAnalogVideoDecoderAvailable;

   ComboBox3->Items->Text = VideoGrabber1->VideoCrossbarInputs;
   ComboBox3->ItemIndex = VideoGrabber1->VideoCrossbarInput;
   ComboBox3->Enabled = VideoGrabber1->IsAnalogVideoDecoderAvailable;

   ComboBox4->Items->Text = VideoGrabber1->VideoSizes;
   ComboBox4->ItemIndex = VideoGrabber1->VideoSize;

   Button5->Enabled = VideoGrabber1->IsDialogAvailable (dlg_VideoCrossbar);
}
//------------------------------------------------------------------------------

// the left side of the motion grid is realigned on the right size of the video preview
//------------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1Resize(TObject *Sender)
{
   Memo1->Left = VideoGrabber1->Left + VideoGrabber1->Width + 10;
   Label10->Left = Memo1->Left;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::UpDown1Click(TObject *Sender, TUDBtnType Button)
{
   if (Button == btNext) {
      MotionDetector1->ChangeGlobalSensitivity (1);
   }
   else {
      MotionDetector1->ChangeGlobalSensitivity (-1);
   }
   Edit3->Text = MotionDetector1->Grid;
}
//------------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
   MotionDetector1->CompareRed = CheckBox1->Checked;
}
//------------------------------------------------------------------------------

void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{
   MotionDetector1->ReduceVideoNoise = CheckBox2->Checked;
}
//------------------------------------------------------------------------------

void __fastcall TForm1::CheckBox3Click(TObject *Sender)
{
   MotionDetector1->CompareGreen = CheckBox3->Checked;
}
//------------------------------------------------------------------------------

void __fastcall TForm1::CheckBox4Click(TObject *Sender)
{
   MotionDetector1->CompareBlue = CheckBox4->Checked;
}
//------------------------------------------------------------------------------

void __fastcall TForm1::CheckBox5Click(TObject *Sender)
{
   MotionDetector1->GreyScale = CheckBox5->Checked;
}
//------------------------------------------------------------------------------

void __fastcall TForm1::Edit3Change(TObject *Sender)
{
   MotionDetector1->Grid = Edit3->Text;
   if (MotionDetector1->IsGridValid()) {
      Shape2->Brush->Color = clLime;
      Label8->Caption = "valid";
   }
   else {
      Shape2->Brush->Color = clRed;
      Label8->Caption = "invalid";
   }
   Memo2->Text = MotionDetector1->Get2DTextGrid();
}
//------------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
   VideoGrabber1->ShowDialog (dlg_Device);
   ComboBox2->ItemIndex = VideoGrabber1->AnalogVideoStandard;
}
//------------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
   MotionDetector1->SetCellSensitivity (StrToInt (Edit2->Text), StrToInt (Edit6->Text), StrToInt (Edit7->Text));
   Edit3->Text = MotionDetector1->Grid;
   Memo2->Text = MotionDetector1->Get2DTextGrid();
}
//------------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
   if ((MotionDetector1->GridXCount() > 30)  || (MotionDetector1->GridYCount() > 30)) {
      ShowMessage ("the grid will be too dense to be edited through the dialog, you should use SetGridCell");
   }
   MotionDetector1->ShowGridDialog();
   Edit3->Text = MotionDetector1->Grid;
}
//------------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
   if (MotionDetector1->SetGridSize (StrToInt (Edit4->Text), StrToInt (Edit8->Text))) {
      Edit3->Text = MotionDetector1->Grid;
      Memo2->Text = MotionDetector1->Get2DTextGrid();
      Memo2->Width = MotionDetector1->GridXCount() * 14;
      Memo1->Width = MotionDetector1->GridXCount() * 14;
      Memo2->Height = MotionDetector1->GridYCount() * 15 + 5;
      Memo1->Height = MotionDetector1->GridYCount() * 15 + 5;
   }
}
//------------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
   VideoGrabber1->ShowDialog (dlg_TVTuner);

}
//------------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
   VideoGrabber1->StartPreview();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
   VideoGrabber1->StopPreview();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{
   VideoGrabber1->VideoDevice = ComboBox1->ItemIndex;
}
//------------------------------------------------------------------------------

void __fastcall TForm1::ComboBox2Change(TObject *Sender)
{
   VideoGrabber1->AnalogVideoStandard = ComboBox2->ItemIndex;
}
//------------------------------------------------------------------------------

void __fastcall TForm1::ComboBox3Change(TObject *Sender)
{
   VideoGrabber1->VideoCrossbarInput = ComboBox3->ItemIndex;
}
//------------------------------------------------------------------------------

void __fastcall TForm1::ComboBox4Change(TObject *Sender)
{
   VideoGrabber1->VideoSize = ComboBox4->ItemIndex;
}
//------------------------------------------------------------------------------


